"{ Package: 'jn:refactoring_custom' }"

Object subclass:#CustomClassQuery
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomClassQuery class methodsFor:'documentation'!

documentation
"
    Helper class for retrieving additional informations from classes.

    [author:]
        Jakub Nesveda <nesvejak@fit.cvut.cz>

"
! !

!CustomClassQuery methodsFor:'queries'!

methodForSuperclassSelector: aSelector class: aClass
    "retrieve method under given selector in class 
    superclass or in superclass superclass until method is found
    or Object is reached"

    | method |

    (aClass == Object) ifTrue: [
        ^ nil
    ].

    method := aClass superclass compiledMethodAt: aSelector asSymbol.
    method isNil ifTrue: [
        ^ self methodForSuperclassSelector: aSelector class: (aClass superclass)
    ] ifFalse: [
        ^ method
    ]

    "Created: / 15-06-2014 / 14:58:31 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

