"{ Package: 'jn:refactoring_custom' }"

TestCase subclass:#CustomClassQueryTests
	instanceVariableNames:'classQuery builder mockSuperClass mockClass'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomClassQueryTests methodsFor:'initialization & release'!

setUp

    classQuery := CustomClassQuery new.
    builder := CustomSourceCodeBuilder new.
    mockSuperClass := builder createClassImmediate: 'MockSuperClassForTestCase' superClassName: 'Object'.
    mockClass := builder createClassImmediate: 'MockClassForTestCase' superClassName: (mockSuperClass new className).

    "Modified: / 15-06-2014 / 16:15:49 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

tearDown

    builder redoChanges

    "Modified: / 15-06-2014 / 16:16:06 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomClassQueryTests methodsFor:'tests'!

test_method_from_superclass_retrieved
    | method |

    self assert: (classQuery methodForSuperclassSelector: 'initialize' class: Object) isNil.

    "/ Instance method
    builder createMethodImmediate: mockSuperClass protocol: 'instance-protocol' source: 'instanceMethod: aParam
    self shouldImplement'.

    method := classQuery methodForSuperclassSelector: #instanceMethod: class: mockClass.
    self assert: 'instance-protocol' = method category.

    self assert: 'instanceMethod:aParam' = method methodDefinitionTemplate.

    "/ Class method
    builder createMethodImmediate: mockSuperClass class protocol: 'class-protocol' source: 'classMethod: aParam
    self shouldImplement'.

    method := classQuery methodForSuperclassSelector: 'classMethod:' class: mockClass class.
    self assert: 'class-protocol' = method category.
    self assert: 'classMethod:aParam' = method methodDefinitionTemplate.

    "Created: / 14-04-2014 / 18:12:57 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 15-06-2014 / 16:17:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

