"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorOrRefactoring subclass:#CustomCodeGenerator
	instanceVariableNames:'builder'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Generators'
!


!CustomCodeGenerator class methodsFor:'instance creation'!

subGeneratorOf: aCodeGenerator
    | codeGenerator nestingCount |

    codeGenerator := self new.
    codeGenerator codeBuilder: aCodeGenerator codeBuilder.
    codeGenerator refactoryBuilder: aCodeGenerator refactoryBuilder.
    codeGenerator userPreferences: aCodeGenerator userPreferences.
    codeGenerator dialog: aCodeGenerator dialog.
    codeGenerator changeManager: aCodeGenerator changeManager.
    codeGenerator compositeChangeCollector: aCodeGenerator compositeChangeCollector.
    nestingCount := aCodeGenerator compositeChangeNesting.
    nestingCount isNil ifTrue: [ 
        nestingCount := 0 
    ].  
    codeGenerator compositeChangeNesting: (1 + nestingCount).
    ^ codeGenerator

    "Created: / 19-04-2014 / 10:15:21 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 23-08-2014 / 00:10:17 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomCodeGenerator class methodsFor:'testing'!

isAbstract
    ^ self == CustomCodeGenerator

    "Created: / 26-01-2014 / 21:38:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CustomCodeGenerator methodsFor:'executing'!

buildInContext: aCustomContext

    self subclassResponsibility

    "Created: / 18-03-2014 / 22:52:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

executeSubGeneratorClasses: aSubGeneratorClasses inContext: aCustomContext

     aSubGeneratorClasses do: [ :aSubGeneratorClass | 
         | subGenerator |

         subGenerator := aSubGeneratorClass subGeneratorOf: self.
         subGenerator executeInContext: aCustomContext  
     ]

    "Created: / 08-07-2014 / 18:31:10 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomCodeGenerator class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

