"{ Package: 'jn:refactoring_custom' }"

TestCase subclass:#CustomCodeGeneratorOrRefactoringTestCaseTests
	instanceVariableNames:'spaceAfterReturnToken maxLengthForSingleLineBlocks
		blockArgumentsOnNewLine'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomCodeGeneratorOrRefactoringTestCaseTests methodsFor:'initialization & release'!

setUp

    spaceAfterReturnToken := RBFormatter spaceAfterReturnToken.
    maxLengthForSingleLineBlocks := RBFormatter maxLengthForSingleLineBlocks.
    blockArgumentsOnNewLine := RBFormatter blockArgumentsOnNewLine.

    "Modified: / 21-08-2014 / 11:53:07 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

tearDown

    RBFormatter spaceAfterReturnToken: spaceAfterReturnToken.
    RBFormatter maxLengthForSingleLineBlocks: maxLengthForSingleLineBlocks.
    RBFormatter blockArgumentsOnNewLine: blockArgumentsOnNewLine.

    "Modified: / 21-08-2014 / 11:54:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomCodeGeneratorOrRefactoringTestCaseTests methodsFor:'tests'!

test_formatter_settings_modified_and_then_restored
    | generatorTestCase |

    generatorTestCase := CustomCodeGeneratorOrRefactoringTestCase new.
    generatorTestCase initalizeTestFormatterSettings.
    generatorTestCase formatterSettings
        at: #spaceAfterReturnToken put: spaceAfterReturnToken not;  
        at: #maxLengthForSingleLineBlocks put: maxLengthForSingleLineBlocks + 10;
        at: #blockArgumentsOnNewLine put: blockArgumentsOnNewLine not.

    generatorTestCase setUpFormatterSettings.

    self assert: (RBFormatter spaceAfterReturnToken) == (spaceAfterReturnToken not).
    self assert: (RBFormatter maxLengthForSingleLineBlocks) == (maxLengthForSingleLineBlocks + 10).
    self assert: (RBFormatter blockArgumentsOnNewLine) == (blockArgumentsOnNewLine not).

    generatorTestCase restoreFormatterSettings.

    self assert: (RBFormatter spaceAfterReturnToken) == spaceAfterReturnToken.
    self assert: (RBFormatter maxLengthForSingleLineBlocks) == maxLengthForSingleLineBlocks.
    self assert: (RBFormatter blockArgumentsOnNewLine) == blockArgumentsOnNewLine.

    "Created: / 21-08-2014 / 11:44:28 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 23-08-2014 / 11:16:37 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

