"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorOrRefactoringTestCase subclass:#CustomReplaceIfNilWithIfTrueRefactoringTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomReplaceIfNilWithIfTrueRefactoringTests methodsFor:'accessing'!

generatorOrRefactoring
    ^ CustomReplaceIfNilWithIfTrueRefactoring new
! !

!CustomReplaceIfNilWithIfTrueRefactoringTests methodsFor:'tests'!

test_if_nil_replaced_with_is_nil_if_true
    | expectedSource class method |

    class := codeBuilder createClassImmediate: 'DummyClassForTestCase01'.
    method := codeBuilder createMethod.
    method
        class: class;
        protocol: 'protocol';
        source: 'selector: arg
        arg ifNil: [ 
            self warn: ''nil''.
        ]
        ifNotNil: [ self information: ''info'' ].
        '.

    context selectedClasses: (Array with: class).  
    codeBuilder execute.

    generatorOrRefactoring executeInContext: context.

    expectedSource := 'selector:arg 
    arg isNil ifTrue:[
        self warn:''nil''.
    ] ifFalse:[
        self information:''info''
    ].'.

    self assertMethodSource: expectedSource atSelector: #selector: forClass: class.

    "Created: / 10-08-2014 / 09:42:07 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 13-08-2014 / 00:33:57 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

