"{ Package: 'jn:refactoring_custom' }"

CustomDialog subclass:#CustomSilentDialog
	instanceVariableNames:'methodAnswers'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomSilentDialog class methodsFor:'documentation'!

documentation
"
    CustomDialog implementation based on non human interaction with dialog answers.
    You may set dialog aswers to inject them in code generators.

    [author:]
        Jakub Nesveda <nesvejak@fit.cvut.cz>

"
! !

!CustomSilentDialog class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize

    "Created: / 11-05-2014 / 11:13:00 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSilentDialog methodsFor:'accessing'!

answer: anAnswer forSelector: aSelector

    methodAnswers 
        at: aSelector 
        put: anAnswer

    "Created: / 11-05-2014 / 00:32:39 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

methodAnswer: aSelector   

    ^ methodAnswers at: aSelector

    "Created: / 11-05-2014 / 00:25:24 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSilentDialog methodsFor:'dialogs'!

requestClassName:aString initialAnswer:anInitialAswer

    ^ self methodAnswer: #requestClassName:initialAnswer:

    "Created: / 11-05-2014 / 00:16:48 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSilentDialog methodsFor:'initialization'!

initialize

    methodAnswers := Dictionary new

    "Created: / 11-05-2014 / 00:19:51 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSilentDialog methodsFor:'user interaction & notifications'!

information: aString

    ^ self

    "Created: / 13-05-2014 / 22:33:51 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSilentDialog class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

