"{ Package: 'jn:refactoring_custom' }"

CustomCodeGenerator subclass:#CustomTestCaseCodeGenerator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Generators'
!


!CustomTestCaseCodeGenerator class methodsFor:'accessing-presentation'!

group
    "Returns a collection strings describing a group to which
     receiver belongs. A groups may be nested hence the array of
     strings. For example for subgroup 'Accessors' in group 'Generators'
     this method should return #('Generators' 'Accessors')."

    "/ By default return an empty array which means the item will appear
    "/ in top-level group.
    ^ #('Testing')

    "Created: / 05-08-2014 / 14:52:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CustomTestCaseCodeGenerator class methodsFor:'queries'!

availableInContext:aCustomContext 
    ^aCustomContext selectedClasses notEmptyOrNil
!

availableInPerspective:aCustomPerspective 
    ^aCustomPerspective isClassPerspective
! !

!CustomTestCaseCodeGenerator class methodsFor:'testing'!

isAbstract
    ^ self == CustomTestCaseCodeGenerator
! !

!CustomTestCaseCodeGenerator methodsFor:'executing'!

buildForClass: aClass testClass: aTestClass
    "Here should be building methods for testclass, altering test class..."

    self subclassResponsibility

    "Created: / 13-06-2014 / 09:28:17 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

buildInContext:aCustomContext 

    aCustomContext selectedClasses do: [ :class |
        | className testClassName |

        className := class theNonMetaClass name.

        (className endsWith: 'Tests') ifFalse: [
            | testClass |

            testClassName := className, 'Tests'.

            testClass := codeBuilder createClass.
            testClass
                className: testClassName;
                superclassName: 'TestCase';
                category: (class category, '-Tests').

            self buildForClass: class testClass: testClass  
        ]
    ]

    "Modified: / 05-07-2014 / 12:27:11 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomTestCaseCodeGenerator class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

